#include <Keypad.h> // changed for wider matrix ulong x ulong

//############################################
//
// for mega / haas matrix keyboard
// if 0 in the standard layout will look in 
// the alternate layout
//
//#############################################

int piezoPin = 13;
const byte ROWS = 13; //changed library to suit
const byte COLS = 11; //changed library to suit
char stdKeys[ROWS][COLS] = {
  {0,0,0,'U',0,'D',    'b','h','n','t','z'},
  {0,0,0,'H','L','E',  'a','g','m','s','y'},
  {0,0,0,0,0,0,         14,'f','l','r','x'},
  {0,0,0,0,0,0,        '-','-','9','0','A'},
  {0,0,0,0,0,0,        '-','-','9','0','A'},
  {0,0,0,0,0,0,        '-','-','9','0','A'},
  {0,0,0,0,0,0,        '-','-','9','0','A'},
  {0,0,0,'u','R','d',  'c','i','o','u','-'},
  {0,0,0,0,0,0,        'd','j','p','v','('},
  {0,0,0,0,0,0,        'e','k','q','w',')'},
  {0,0,0,0,0,0,       '7','4','1','-','B'},
  {0,0,0,0,0,0,       '8','5','2','0',' '},
  {0,0,0,0,0,0,       '9','6','3','.',13},
};

char altKeys[ROWS][COLS] = {
  {0, 'Q', 'Q', 0, 'Q', 0, 0, 0, 0, 0, 0},
  {'Q', 'Q', 'Q', 0, 0, 0, 0, 0, 0, 0, 0},
  {'Q', 0, 'Q', 'Q', 'Q', 'Q', 0, 0, 0, 0, 0},
  {0, 0, 'Q', 'Q', 'Q', 'Q', 'Q', 'Q', 'Q', 'Q', 'Q'},
  {0, 0, 'Q', 'Q', 'Q', 'Q', 'Q', 'Q', 'Q', 'Q', 'Q'},
  {0, 0, 'Q', 'Q', 'Q', 'Q', 'Q', 'Q', 'Q', 'Q', 'Q'},
  {'Q', 0, 'Q', 'Q', 'Q', 'Q', 'Q', 'Q', 'Q', 'Q', 'Q'},
  {'Q', 'Q', 'Q', 0, 0, 0, 0, 0, 0, 0, 0},
  {'Q', 'Q', 'Q', 'Q', 'Q', 'Q', 'Q', 0, 0, 0, 0},
  {0, 'Q', 'Q', 'Q', 'Q', 'Q', 0, 0, 0, 0, 0},
  {0, 'Q', 'Q', 'Q', 'Q', 'Q', 0, 0, 0, 0, 0},
  {0, 'Q', 'Q', 'Q', 'Q', 'Q', 0, 0, 0, 0, 0},
  {0, 'Q', 'Q', 'Q', 'Q', 'Q', 0, 0, 0, 0, 0},
};

unsigned long loopCount;
unsigned long startTime;
String msg;
int shifted = 0;

byte rowPins[ROWS] = {47, 45, 43, 41, 39, 37, 35, 33, 31, 29, 27, 25, 23}; //connect to the row pinouts of the keypad
byte colPins[COLS] = {12,11,10,9,8,7,6,5,4,3,2}; //connect to the column pinouts of the keypad

Keypad stdpad = Keypad( makeKeymap(stdKeys), rowPins, colPins, ROWS, COLS );

void setup(){
    Serial.begin(9600);
    loopCount = 0;
    startTime = millis();
    msg = "";
}

void loop() {
    loopCount++;
    if ( (millis()-startTime)>5000 ) {
        Serial.print("Average loops per second = ");
        Serial.println(loopCount/5);
        startTime = millis();
        loopCount = 0;
    }

    // Fills stdpad.key[ ] array with up-to 10 active keys.
    // Returns true if there are ANY active keys.
    if (stdpad.getKeys())
    {
        for (int i=0; i<LIST_MAX; i++)   // Scan the whole key list.
        {
            if ( stdpad.key[i].stateChanged )   // Only find keys that have changed state.
            {
                switch (stdpad.key[i].kstate) {  // Report active key state : IDLE, PRESSED, HOLD, or RELEASED
                    case PRESSED:
                      switch( stdpad.key[i].kchar ) {
                        case 0:
                        Serial.print(((char*)altKeys)[stdpad.key[i].kcode]);
                        tone(piezoPin, 500, 100);
                        break;
                        case 13:
                          Serial.println();
                          tone(piezoPin, 2000, 200);
                          break;
                        case 14:
                          tone(piezoPin, 1000, 100);
                          shifted = 1;
                          break;
                        default:
                          tone(piezoPin, 1000, 100);
                          Serial.print("Key ");
                          Serial.print(stdpad.key[i].kchar);
                          if (shifted){
                            Serial.println(" Pressed/Shifted.");
                          } else {
                            Serial.println(" Pressed.");
                          }
                        }
                      break;
                break;
                    case HOLD:
                      tone(piezoPin, 2500, 100);
                break;
                    case RELEASED:
                      switch( stdpad.key[i].kchar ) {
                        case 13:
                          Serial.println();
                          break;
                        case 14:
                          shifted = 0;
                          break;
                        default:
                          Serial.print("Key ");
                          Serial.print(stdpad.key[i].kchar);
                          if (shifted){
                            Serial.println(" Released/Shifted.");
                          } else {
                            Serial.println(" Released.");
                          }
                        }
                      break;
                }
            }
        }
    }
}  // End loop
